// HarkFileIO.cpp: CHarkFileIO NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "HarkFileIO.h"
using namespace harkio;
using namespace std ;
#include <vector>

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CHarkFileIO::CHarkFileIO()
{
	
}

CHarkFileIO::~CHarkFileIO()
{
}
// --------------------------------------------------------------------
bool CHarkFileIO::WriteData(const char* cFilename,
						MICARY_TFDBFileHeader *psTFDBHead,
						MICARY_ComplexArray micary_cmpaData,
						MICARY_IntArray	micary_iaFreqLine,
						MICARY_LocationArray micary_locaSource,
						MICARY_LocationArray micary_locaMic,
						const char* cDate,
						const char* cLocation,
						const char* cRobot,
						const char* cArrayType,
						const char * cCreator,
						const char* cMemo)
{
	// HGTF DataIuWFNg̐
	HARK hark;
	Data *hgtf = NULL;
	FMT *fmt = NULL ;
	GTF *gtf = NULL ;
	SM *sm = NULL ; 
	SPEC *spec = NULL ;
		
	try{
		int nMic,nSrc,nFrq,nFFT,nFs ;
		int ii,jj,kk,index ;
		vector<int> *fi ;
		GTF::SRC_LIST_TYPE *src_tf ;
		GTF::TF_LIST_TYPE *tf ; 
		SM::SRC_LIST_TYPE *src;
		SM::SM_LIST_TYPE *sm_data;
		
		
		hgtf = new HGTF() ;
		// mHarkdata̒ǉ
		hark.addData(hgtf) ;
	
		nMic = psTFDBHead->lNMic ;
		nSrc = psTFDBHead->lNSrc ;
		nFFT = psTFDBHead->lNFFT ;
		nFs = psTFDBHead->lFs ;
		nFrq = psTFDBHead->lNFreq ;

		//FMT`N̍쐬
		if(psTFDBHead->iFileType == FORMAT_TYPE_TF){ 
			fmt = new FMT(FMT::V1_0,FMT::GTF,nMic,nFFT,nFFT,nFs) ;
		}
		else if(psTFDBHead->iFileType == FORMAT_TYPE_W){
			fmt = new FMT(FMT::V1_0,FMT::SM,nMic,nFFT,nFFT,nFs) ;
		}
		hgtf->addChunk(fmt) ;
	
		// FMT Chunkփ}CNWRei𐶐āCTvf[^Zbg
		FMT::MIC_LIST_TYPE *mic = fmt->newMic() ;	//}CNWRei̐
	
		//f[^Zbg
		for(ii = 0 ; ii < nMic ; ii++){
			(*mic)[ii].x = micary_locaMic.micary_Location[ii].ha_fX ;
			(*mic)[ii].y = micary_locaMic.micary_Location[ii].ha_fY ;
			(*mic)[ii].z = micary_locaMic.micary_Location[ii].ha_fZ ;
			
		}
		
       		//`N̍쐬
		switch(psTFDBHead->iFileType){
		case FORMAT_TYPE_TF :
				gtf = new GTF(GTF::V1_0,fmt,nSrc,nFrq) ;
			     	hgtf->addChunk(gtf) ;
				
				//Chunk特ʒuWRei擾āCeXgf[^Zbg
				src_tf = gtf->getSrc() ;
			
				//f[^Zbg
				for(ii = 0 ; ii < nSrc ; ii++){
					(*src_tf)[ii].x = micary_locaSource.micary_Location[ii].ha_fX ;
					(*src_tf)[ii].y = micary_locaSource.micary_Location[ii].ha_fY ;
					(*src_tf)[ii].z = micary_locaSource.micary_Location[ii].ha_fZ ;
			     

				}

				//Chunk`B֐Rei擾āCeXgf[^Zbg
				tf = gtf->getTF() ;
			
				//f[^Zbg(Src->Mic->Freq)
				index = 0 ;
				for(kk = 0 ; kk < nFrq ; kk++){			
					for(ii = 0 ; ii < nSrc ; ii++){
						for(jj = 0 ; jj < nMic ; jj++){
							(*tf)[ii][jj][kk].real() = micary_cmpaData.ha_cmpValue[index].re ;
							(*tf)[ii][jj][kk].imag() = micary_cmpaData.ha_cmpValue[index].im ;
							index++ ;
					      
						}
					}
				}

			
				//`B֐̎gCfbNXCfbNXւ̃}bv
				//Rei擾
				fi = gtf->getFI() ;
				cout << "NFrq = " << nFrq << endl ;
			
				//f[^Zbg
				for(ii = 0 ; ii < nFrq ; ii++){
					(*fi)[ii] = micary_iaFreqLine.ha_iValue[ii] ;
			      	}
			       
				break ;
		case FORMAT_TYPE_W :
				sm = new SM(SM::V1_0,fmt,nSrc,nFrq) ;
				hgtf->addChunk(sm) ;

				//Chunk特ʒuWRei擾āCeXgf[^Zbg
				src = sm->getSrc() ;
		
				//f[^Zbg
				for(ii = 0 ; ii < nSrc ; ii++){
					(*src)[ii].x = micary_locaSource.micary_Location[ii].ha_fX ;
					(*src)[ii].y = micary_locaSource.micary_Location[ii].ha_fY ;
					(*src)[ii].z = micary_locaSource.micary_Location[ii].ha_fZ ;
				}

				//Chunk`B֐Rei擾āCeXgf[^Zbg
				sm_data = sm->getSM() ;

				//f[^Zbg(Src->Mic->Freq)
				index = 0 ;
				for(kk = 0 ; kk < nFrq ; kk++){			
					for(jj = 0 ; jj < nMic ; jj++){
						for(ii = 0 ; ii < nSrc ; ii++){
							(*sm_data)[ii][jj][kk].real() = micary_cmpaData.ha_cmpValue[index].re ;
							(*sm_data)[ii][jj][kk].imag() = micary_cmpaData.ha_cmpValue[index].im ;
							index++ ;
						}
					}
				}

				//s̎gCfbNXCfbNXւ̃}bv
				//Rei擾
				fi = sm->getFI() ;

				//f[^Zbg
				for(ii = 0 ; ii < nFrq ; ii++){
					(*fi)[ii] = micary_iaFreqLine.ha_iValue[ii] ;
				}
				break ;
		
		}
		
		//ʁ@SPEC`N̍쐬
		spec = new SPEC(SPEC::V1_0) ;
		
		hgtf->addChunk(spec) ;
		

		//SPECf[^̍쐬
		spec->setDate(cDate) ;
		spec->setLocation(cLocation) ;
		spec->setRobot(cRobot) ;
		spec->setArrayType(cArrayType) ;
		spec->setCreator(cCreator) ;
		spec->setMemo(cMemo) ;

		//hark
		hark.writeFile(cFilename) ;
		
	}
	catch(std::exception &ex){
	
		return false ;
	
	}

	//	cout << "Success Write Hark file" << endl ;
	return true ;
}

bool CHarkFileIO::ReadInfo(const char* cFilename,
					MICARY_TFDBFileHeader *psTFDBHead,
					MICARY_LocationArray * plocaSrcPos , 
					MICARY_LocationArray * plocaMicPos ,
			   MICARY_IntArray *piaFreqLine,
			   bool bInfo)
{
	if(HARK::checkIdentifier(cFilename) != HARKIO_TRUE){
		cout << "Fail to Read Hark File." << endl ;
		return false ;
	}
	HARK hark ;
	FMT *fmt ;
	GTF *gtf ;
	SM *sm ;
	int i ,j , k;
	GTF::SRC_LIST_TYPE *src_tf ;
	vector<int> *fi ;
	SM::SRC_LIST_TYPE *src ;
	FMT::MIC_LIST_TYPE *mic ;

	try{
		//t@Cǂݍ
		hark.readFile(cFilename) ;
		
		Chunk::VERSION_CHECK version_check ;
		// FMT`N
		fmt = hark.getData()->getChunk<FMT>() ;

		//o[W`FbN
		version_check = fmt->checkVersion(FMT::V1_0) ;
		if(version_check == Chunk::MISMATCH){
			return false ;
		}
		else if(version_check == Chunk::SAFE_MATCH){
			cout << harkio::Error::getInstance().getMsg() << endl ;
		}
		// Mic,Freq̊mF
		if(plocaMicPos->ha_numLocation != fmt->getNMic()){
			cout << "Mic number is mismatch !" << endl ;
			return false ;
		}
		
		psTFDBHead->iFileType = fmt->getFormatId() ;
		psTFDBHead->lFs = fmt->getNFS() ;
		psTFDBHead->lNMic = fmt->getNMic() ;
		psTFDBHead->lNFFT = fmt->getNFFT() ;
		psTFDBHead->lFs = fmt->getNFS() ;

		mic = fmt->getMic() ;
		for(i = 0 ; i < fmt->getNMic() ; i++){
			plocaMicPos->micary_Location[i].ha_fX = (*mic)[i].x ;
			plocaMicPos->micary_Location[i].ha_fY = (*mic)[i].y ;
			plocaMicPos->micary_Location[i].ha_fZ = (*mic)[i].z ;
			plocaMicPos->micary_Location[i].ha_idPos = 0;//dummy
			//plocaMicPos->ha_idLocation[i] = plocaSrcPos->micary_Location[i].ha_idPos ;
		}


		switch(psTFDBHead->iFileType){
		case FORMAT_TYPE_TF :	//GTF`N̓Ǎ
			gtf = hark.getData()->getChunk<GTF>() ;
			//o[W`FbN
			version_check = gtf->checkVersion(GTF::V1_0) ;
			if(version_check == Chunk::MISMATCH){
				cout << harkio::Error::getInstance().getMsg() << endl ;
				return false ;
			}
			else if(version_check == Chunk::SAFE_MATCH){
				cout << harkio::Error::getInstance().getMsg() << endl ;
			}
			if(plocaSrcPos->ha_numLocation != gtf->getNSrc()){
				cout << "Source number is mismatch!" << endl ;
				return false ;
			}
			if(piaFreqLine->ha_numValue != gtf->getNFI()){
				cout << "FreqLine number is mismatch!" << endl ;
				return false ;
			}
			psTFDBHead->lNSrc = gtf->getNSrc() ;
			psTFDBHead->lNFreq = gtf->getNFI() ;
			
			//ʒuW̓Ǎ
			src_tf = gtf->getSrc() ;
			for(i = 0 ; i < src_tf->size() ; i++){
				plocaSrcPos->micary_Location[i].ha_fX = (*src_tf)[i].x ;
				plocaSrcPos->micary_Location[i].ha_fY = (*src_tf)[i].y ;
				plocaSrcPos->micary_Location[i].ha_fZ = (*src_tf)[i].z ;
				plocaSrcPos->micary_Location[i].ha_idPos = 0 ; //dummy
				plocaSrcPos->ha_idLocation[i] = plocaSrcPos->micary_Location[i].ha_idPos ;
			}

			//gC̓Ǎ
			fi = gtf->getFI() ;
			for(i = 0 ; i < fi->size() ; i++){
				piaFreqLine->ha_iValue[i] = (*fi)[i] ;
			}
		break ;

		case FORMAT_TYPE_W:
			sm = hark.getData()->getChunk<SM>() ;
			//o[W`FbN
			version_check = sm->checkVersion(SM::V1_0) ;
			
			if(version_check == Chunk::MISMATCH){
				cout << harkio::Error::getInstance().getMsg() << endl ;
				return false ;
			}
			else if(version_check == Chunk::SAFE_MATCH){
				cout << harkio::Error::getInstance().getMsg() << endl ;
			}
			if(plocaSrcPos->ha_numLocation != sm->getNSrc()){
				cout << "Source number is mismatch!" << endl ;
				return false ;
			}
			if(piaFreqLine->ha_numValue != sm->getNFI()){
				cout << "FreqLine number is mismatch!" << endl ;
				return false ;
			}
			psTFDBHead->lNSrc = sm->getNSrc() ;
			psTFDBHead->lNFreq = sm->getNFI() ;
			
			//ʒuW̓Ǎ
			src = sm->getSrc() ;
			for(i = 0 ; i < src->size() ; i++){
				plocaSrcPos->micary_Location[i].ha_fX = (*src)[i].x ;
				plocaSrcPos->micary_Location[i].ha_fY = (*src)[i].y ;
				plocaSrcPos->micary_Location[i].ha_fZ = (*src)[i].z ;
				plocaSrcPos->micary_Location[i].ha_idPos = 0;//dummy
				plocaSrcPos->ha_idLocation[i] = plocaSrcPos->micary_Location[i].ha_idPos ;
			}

			//gC̓Ǎ
			fi = sm->getFI() ;
			for(i = 0 ; i < fi->size() ; i++){
				piaFreqLine->ha_iValue[i] = (*fi)[i] ;
			}

		break ;
	}
	//SPEC`N̓e
	SPEC *spec = hark.getData()->getChunk<SPEC>() ;

	//o[W`FbN
	version_check = spec->checkVersion(SPEC::V1_0) ;
	if(version_check == Chunk::MISMATCH){
		cout << harkio::Error::getInstance().getMsg() << endl ;
		return false ;
	}
	else if(version_check == Chunk::SAFE_MATCH){
		cout << harkio::Error::getInstance().getMsg() << endl ;
	}
	
	if(bInfo){
	cout << "Date = " << spec->getDate() << endl ;
	cout << "Location = " << spec->getLocation() << endl ;
	cout << "Robot = " << spec->getRobot() << endl ;
	cout << "ArrayType = " << spec->getArrayType() << endl ;
	cout << "Creator = " << spec->getCreator() << endl ;
	cout << "Memo = " << spec->getMemo() << endl ;
	}
	}
	catch(std::exception &ex){
		return false ;
	}
	return true ;

}
bool CHarkFileIO::ReadHeader(const char* cFilename,
				MICARY_TFDBFileHeader *psTFDBHead)
{
	if(HARK::checkIdentifier(cFilename) != HARKIO_TRUE){
		cout << "Fail to Read Hark File." << endl ;
		return false ;
	}
	HARK hark ;
	FMT *fmt ;
	GTF *gtf ;
	SM *sm ;
	int i ,j , k;

	try{
		//t@Cǂݍ
		hark.readFile(cFilename) ;
		
		Chunk::VERSION_CHECK version_check ;
		// FMT`N
		fmt = hark.getData()->getChunk<FMT>() ;

		//o[W`FbN
		version_check = fmt->checkVersion(FMT::V1_0) ;
		if(version_check == Chunk::MISMATCH){
			return false ;
		}
		else if(version_check == Chunk::SAFE_MATCH){
			cout << harkio::Error::getInstance().getMsg() << endl ;
		}
		
		psTFDBHead->iFileType = fmt->getFormatId() ;
		psTFDBHead->lFs = fmt->getNFS() ;
		psTFDBHead->lNMic = fmt->getNMic() ;
		psTFDBHead->lNFFT = fmt->getNFFT() ;
		psTFDBHead->lFs = fmt->getNFS() ;
		
		switch(psTFDBHead->iFileType){
		case FORMAT_TYPE_TF :	//GTF`N̓Ǎ
			gtf = hark.getData()->getChunk<GTF>() ;
			//o[W`FbN
			version_check = gtf->checkVersion(GTF::V1_0) ;
			if(version_check == Chunk::MISMATCH){
				cout << harkio::Error::getInstance().getMsg() << endl ;
				return false ;
			}
			else if(version_check == Chunk::SAFE_MATCH){
				cout << harkio::Error::getInstance().getMsg() << endl ;
			}
			psTFDBHead->lNSrc = gtf->getNSrc() ;
			psTFDBHead->lNFreq = gtf->getNFI() ;
		break ;

		case FORMAT_TYPE_W:
			sm = hark.getData()->getChunk<SM>() ;
			//o[W`FbN
			version_check = sm->checkVersion(SM::V1_0) ;
			
			if(version_check == Chunk::MISMATCH){
				cout << harkio::Error::getInstance().getMsg() << endl ;
				return false ;
			}
			else if(version_check == Chunk::SAFE_MATCH){
				cout << harkio::Error::getInstance().getMsg() << endl ;
			}
			psTFDBHead->lNSrc = sm->getNSrc() ;
			psTFDBHead->lNFreq = sm->getNFI() ;
			

		break ;
	   }
	}
	catch(std::exception &ex){
		return false ;
	}
	return true ;	

}
bool CHarkFileIO::ReadData(const char*cFilename,
					MICARY_ComplexArray *micary_cmpaData)
{
	if(HARK::checkIdentifier(cFilename) != HARKIO_TRUE){
		cout << "Fail to Read Hark File." << endl ;
		return false ;
	}
	HARK hark ;
	FMT *fmt ;
	GTF *gtf ;
	SM *sm ;
	int i ,j , k;
	int index;
	GTF::TF_LIST_TYPE *tf ;
	SM::SM_LIST_TYPE *sm_data ;

	try{
		//t@Cǂݍ
		hark.readFile(cFilename) ;
		
		Chunk::VERSION_CHECK version_check ;
		// FMT`N
		fmt = hark.getData()->getChunk<FMT>() ;

		//o[W`FbN
		version_check = fmt->checkVersion(FMT::V1_0) ;
		if(version_check == Chunk::MISMATCH){
			return false ;
		}
		else if(version_check == Chunk::SAFE_MATCH){
			cout << harkio::Error::getInstance().getMsg() << endl ;
		}
	
		switch(fmt->getFormatId()){
		case FORMAT_TYPE_TF :	//GTF`N̓Ǎ
			gtf = hark.getData()->getChunk<GTF>() ;
			//o[W`FbN
			version_check = gtf->checkVersion(GTF::V1_0) ;
			if(version_check == Chunk::MISMATCH){
				cout << harkio::Error::getInstance().getMsg() << endl ;
				return false ;
			}
			else if(version_check == Chunk::SAFE_MATCH){
				cout << harkio::Error::getInstance().getMsg() << endl ;
			}
						
			//`B֐f[^̓Ǎ
			tf = gtf->getTF() ;
			if(micary_cmpaData->ha_numValue != gtf->getNFI()*gtf->getNSrc()*fmt->getNMic()){
			  cout << "TF Data size is mismatch! Nbuf = " << micary_cmpaData->ha_numValue << " Nfile = " << gtf->getNFI()*gtf->getNSrc() *fmt->getNMic() << endl ;
				return false ;
			}
			//cout << "NF = " << gtf->getNFI() << "NS = " << gtf->getNSrc() << "NM = " << fmt->getNMic() << endl ;
 
		
			index = 0 ;
			for(k = 0 ; k < gtf->getNFI() ; k++){
				for(j = 0 ; j < gtf->getNSrc() ; j ++){
					for(i = 0 ; i < fmt->getNMic() ; i++){
					  micary_cmpaData->ha_cmpValue[index].re =(HA_Float) (*tf)[j][i][k].real() ;
					  micary_cmpaData->ha_cmpValue[index].im =(HA_Float) (*tf)[j][i][k].imag() ;
					  //cout << "index = " << index << micary_cmpaData->ha_cmpValue[index].re<< " , " << micary_cmpaData->ha_cmpValue[index].im ;
					  index++ ;
					}
				}
			}
			//	cout << endl ;
		break ;

		case FORMAT_TYPE_W:
			sm = hark.getData()->getChunk<SM>() ;
			//o[W`FbN
			version_check = sm->checkVersion(SM::V1_0) ;
			
			if(version_check == Chunk::MISMATCH){
				cout << harkio::Error::getInstance().getMsg() << endl ;
				return false ;
			}
			else if(version_check == Chunk::SAFE_MATCH){
				cout << harkio::Error::getInstance().getMsg() << endl ;
			}
			
			//`B֐f[^̓Ǎ
			sm_data = sm->getSM() ;
			if(micary_cmpaData->ha_numValue != sm->getNFI()*sm->getNSrc()*fmt->getNMic()){
			  cout << "W Data size is mismatch! Nbuf = " << micary_cmpaData->ha_numValue << " Nfile = " << sm->getNFI()*sm->getNSrc() *fmt->getNMic() << endl ;
				return false ;
			}
		index = 0 ;
			for(k = 0 ; k < sm->getNFI() ; k++){
				for(j = 0 ; j < fmt->getNMic() ; j ++){
					for(i = 0 ; i < sm->getNSrc() ; i++){
					  micary_cmpaData->ha_cmpValue[index].re = (HA_Float)(*sm_data)[i][j][k].real() ;
					  micary_cmpaData->ha_cmpValue[index].im = (HA_Float)(*sm_data)[i][j][k].imag() ;
					  index++ ;
					}
				}
			}
		
			break ;
		}
	}
	catch(std::exception &ex){
		return false ;
	}
	//cout << "Success Read Hark Data." << endl ;
	return true ;
}

bool CHarkFileIO::ConvertToGHDSS(const char* cOrgFilename,
						const char * cNewFilename)
{
	 MICARY_TFDBFileHeader *psH ;
	 MICARY_TFDatabase *pDBase ;
	 MICARY_PrmFrame pFrame ;

	 bool bRtn ;

     psH = new MICARY_TFDBFileHeader() ;
	 pDBase = new MICARY_TFDatabase() ;
	 TFDatabaseAlloc(pDBase,0,0,0) ;

	  bRtn =ReadHeader(cOrgFilename,psH) ;
	  if(!bRtn){
			cout << "Fail to Read HARK Header" << endl ;
			if(pDBase){
			  delete [] pDBase ;
			  pDBase = NULL ;
			}
			if(psH){
				delete [] psH ;
				psH = NULL ;
			}
			return false;
	  }

	  if(pDBase->micary_cmpaTF.ha_numValue != psH->lNFreq * psH->lNMic * psH->lNSrc){
		  TFDatabaseAlloc(pDBase,psH->lNFreq,psH->lNSrc,psH->lNMic) ;
	  }

	  //wb_Ƃ̑Ӄf[^̓Ǎ
		bRtn = ReadInfo(cOrgFilename,
					psH,
					&pDBase->micary_locaSource , 
					&pDBase->micary_locaMic,
					&pDBase->micary_iaFreqLine);
	  if(!bRtn){
		cout << "Fail to Read HARK Header" << endl ;
		if(pDBase){
			delete [] pDBase ;
			pDBase = NULL ;
		}
		if(psH){
		  delete [] psH ;
		  psH = NULL ;
		}
		return false;
	}


	  //f[^̓Ǎ
	bRtn = ReadData(cOrgFilename,&pDBase->micary_cmpaTF)  ;

	if(!bRtn){
		cout << "Fail to Read HARK Data" << endl ;
		if(pDBase){
			delete [] pDBase ;
			pDBase = NULL ;
		}
		if(psH){
		  delete [] psH ;
		  psH = NULL ;
		}
		return false;
	}
	
	cout << "Data" << endl ; 
	for(int i = 0 ; i < pDBase->micary_cmpaTF.ha_numValue ; i++){
	  cout << "i = "<< i << "/" << pDBase->micary_cmpaTF.ha_cmpValue[i].re << " , " << pDBase->micary_cmpaTF.ha_cmpValue[i].im ; //<< endl;
	}
	cout << endl ;
	

	return true ;
	 
}

bool CHarkFileIO::LoadPositionData(const char* cFilename,
					MICARY_LocationArray * plocaPos)
{
  int type ;
  int Npos ;
  unsigned int i ;
  harkio::TextData files ;
  harkio::TextBase *file ;

  file = files.readFile(cFilename);
  type = files.checkFileIdentifier(cFilename) ;
  
  switch(type){
  case harkio::TextData::TYPE::MICARYLocationFile :
    // }CNt@C̏ꍇ
    harkio::MICARYLocationFile* micfile ;
    file = files.readFile(cFilename) ;
    micfile = ((harkio::MICARYLocationFile*) file) ;
    micfile->atLeastVersion(harkio::MICARYLocationFile::V1_0) ;
    
    Npos = micfile->mic_lists.size() ;
    if(Npos != plocaPos->ha_numLocation){
      if(plocaPos){
	LocationArrayFree(plocaPos) ;
      }
      LocationArrayAlloc(plocaPos,Npos) ;		 
    }  
  
    for(i = 0 ; i < Npos ;i++){
      plocaPos->micary_Location[i].ha_fX = micfile->mic_lists[i].x ;
      plocaPos->micary_Location[i].ha_fY = micfile->mic_lists[i].y ;
      plocaPos->micary_Location[i].ha_fZ = micfile->mic_lists[i].z ;
      // U
      plocaPos->micary_Location[i].ha_idPos =i ;
      plocaPos->ha_idLocation[i] = i ;
    }
    delete micfile ;
    break ;
  case harkio::TextData::TYPE::NoiseLocationFile :
    // mCYt@C̏ꍇ
    harkio::NoiseLocationFile* noisefile ;
    file = files.readFile(cFilename) ;
    noisefile = ((harkio::NoiseLocationFile*) file) ;
    noisefile->atLeastVersion(harkio::NoiseLocationFile::V1_0) ;
   
    Npos = noisefile->noise_lists.size() ;
    if(Npos != plocaPos->ha_numLocation){
      if(plocaPos){
	LocationArrayFree(plocaPos) ;
      }
      LocationArrayAlloc(plocaPos,Npos) ;		 
    }  
  
    for(i = 0 ; i < Npos ;i++){
      plocaPos->micary_Location[i].ha_fX = noisefile->noise_lists[i].x ;
      plocaPos->micary_Location[i].ha_fY = noisefile->noise_lists[i].y ;
      plocaPos->micary_Location[i].ha_fZ = noisefile->noise_lists[i].z ;
      // U
      plocaPos->micary_Location[i].ha_idPos = i ;
      plocaPos->ha_idLocation[i] = i ;
    }
    delete noisefile ;
    break ;
  default :
    cout << "Unknown File Type:" << cFilename << endl ;
    break ;
  }
  
  return true ;
}
bool CHarkFileIO::LoadPositionData(const char* cFilename,
					MICARY_LocationArray * plocaPos,int iFileType)
{
 	if(!cFilename || !plocaPos){
		return false ;
	}
	
	string TAG_TITLE ;
	// file open
	std::ifstream ifs(cFilename) ;

	if(ifs.fail()){
		cout << "Can't open Position file " << endl ;
		return false ;
	}

	if(iFileType == __FILE_TYPE_MIC){
		TAG_TITLE = "MICARY-LocationFile" ;
	}
	else{
		TAG_TITLE = "Noise-LocationFile" ;
	}
	string TAG_VERSION = "Version" ;
	string TAG_NUM_POSITION = "NumOfPosition" ;
	string TAG_POSITION	= "Position" ;

	const int BUF = 1024 ;
        char buf[BUF] ;
	
	int Npos ;
	int index = 0 ;

	memset(buf,'\0',BUF) ;

	string tag ;
	string line_val ;
	string line ;
	int offset ;

        cout << "Read File = " << cFilename << endl ;
	
	// TAG_TITLE
	ifs.getline(buf,1024) ;
	line = buf ;

	cout << "File_type = " << buf << endl ;

	//if(line != TAG_TITLE){
	if(line.find(TAG_TITLE) == -1){
		cout << "File format is different." << endl ;
		ifs.close() ;
		return false ;
	}
	

	// TAG_VERSION
	ifs.getline(buf,1024) ;
	line = buf ;
	offset = line.find(TAG_VERSION) ;

	if(offset == -1){
		cout << "File version is different." << endl ;
		ifs.close() ;
		return false ;
	}
	else{
		cout << line  << endl ;
	}

	while(!ifs.eof()){
	 
	  // 2010.7.9
	  // ifs.getline(buf,1024,'\r\n') ;
	  //  line = buf ;
	  ifs.getline(buf,1024) ;
	  line = buf ;
	 	  
		// Rg
		offset = line.find_first_of("#");
		if(offset == 0){
		  cout << line << endl ;
			continue ;
		}

		// TAG_NUMOFPOSITION
		offset = line.find_first_of("=") ;
		// TAGƒl̕
		if(offset != -1){	//NumOfPosition
			tag = line.substr(0,offset) ;
			line_val = line.substr(offset+1) ;
			if(tag == TAG_NUM_POSITION){
				Npos = atoi(line_val.c_str()) ;
				cout << "NumberOfPosition = " << line_val <<  endl ;
				if(Npos != plocaPos->ha_numLocation){
				   if(plocaPos){
				    LocationArrayFree(plocaPos) ;
				  }
				   cout << "alloc" << endl ;
				  LocationArrayAlloc(plocaPos,Npos) ;
				 
				}  
				
				continue ;
			}
		}
		
		// Position
		//cout << line << endl ;
		offset = line.find_first_of(' ') ;
	
		if(offset != -1){
			tag = line.substr(0,offset) ;
			line_val = line.substr(offset+1) ;
			
			if(tag == TAG_POSITION){
				string line_new ;
				int offset_new = 0 ;
				float pos[3] ;
				int id ;
				for(int i = 0 ; i <= 3 ; i++){
				  if(i == 3){
				  	  pos[i-1] = atof(line_val.c_str()) ;
					  break ;
				  }  
				  offset_new = line_val.find_first_of(",") ;
				  if(offset_new == -1){
					break ;
				  }
				  line_new = line_val.substr(0,offset_new) ;
				  if(i == 0){
					id = atoi(line_new.c_str()) ;
				  }
				  else{
					pos[i-1] = atof(line_new.c_str()) ;
				  }
				  line_val = line_val.substr(offset_new+1) ;
				}
				//if(index < Npos){
				if(index < Npos){
			            plocaPos->micary_Location[index].ha_fX = pos[0] ;
				    plocaPos->micary_Location[index].ha_fY = pos[1] ;
				    plocaPos->micary_Location[index].ha_fZ = pos[2] ;
				    plocaPos->micary_Location[index].ha_idPos =id ;
				    plocaPos->ha_idLocation[index] = id ;
				    //index++ ;
				  
				  cout << "position " << id << " " << plocaPos->micary_Location[index].ha_fX << "," << plocaPos->micary_Location[index].ha_fY << "," << plocaPos->micary_Location[index].ha_fZ << endl ;
				  index++ ;
				} 
						  
			}
		}
	}
 
	return true ;
  

}
